/*!
 * ng2-dynamic-forms 1.0.0-beta.17 2016-09-15 09:41 UTC Copyright (c) 2016, Udo Schöfer
 * 
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@angular/core"), require("@angular/common"), require("@angular/forms"), require("@ng2-dynamic-forms/core"));
	else if(typeof define === 'function' && define.amd)
		define(["@angular/core", "@angular/common", "@angular/forms", "@ng2-dynamic-forms/core"], factory);
	else if(typeof exports === 'object')
		exports["@ng2-dynamic-forms/ui-bootstrap/ui-bootstrap"] = factory(require("@angular/core"), require("@angular/common"), require("@angular/forms"), require("@ng2-dynamic-forms/core"));
	else
		root["ng2-dynamic-forms"] = root["ng2-dynamic-forms"] || {}, root["ng2-dynamic-forms"]["@ng2-dynamic-forms/ui-bootstrap/ui-bootstrap"] = factory(root["@angular/core"], root["@angular/common"], root["@angular/forms"], root["@ng2-dynamic-forms/core"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_16__, __WEBPACK_EXTERNAL_MODULE_17__, __WEBPACK_EXTERNAL_MODULE_18__, __WEBPACK_EXTERNAL_MODULE_22__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	function __export(m) {
	    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
	}
	__export(__webpack_require__(24));
	__export(__webpack_require__(25));

/***/ },
/* 1 */,
/* 2 */,
/* 3 */,
/* 4 */,
/* 5 */,
/* 6 */,
/* 7 */,
/* 8 */,
/* 9 */,
/* 10 */,
/* 11 */,
/* 12 */,
/* 13 */,
/* 14 */,
/* 15 */,
/* 16 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_16__;

/***/ },
/* 17 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_17__;

/***/ },
/* 18 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_18__;

/***/ },
/* 19 */,
/* 20 */,
/* 21 */,
/* 22 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_22__;

/***/ },
/* 23 */,
/* 24 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var core_1 = __webpack_require__(16);
	var forms_1 = __webpack_require__(18);
	var core_2 = __webpack_require__(22);
	exports.DYNAMIC_FORM_UI_BOOTSTRAP = "BOOTSTRAP";
	var DynamicFormBootstrapComponent = (function (_super) {
	    __extends(DynamicFormBootstrapComponent, _super);
	    function DynamicFormBootstrapComponent() {
	        _super.call(this);
	        this.hasSuccessStyles = false;
	        this.hasErrorStyles = false;
	        this.type = exports.DYNAMIC_FORM_UI_BOOTSTRAP;
	    }
	    __decorate([
	        core_1.Input(), 
	        __metadata('design:type', forms_1.FormGroup)
	    ], DynamicFormBootstrapComponent.prototype, "controlGroup", void 0);
	    __decorate([
	        core_1.Input(), 
	        __metadata('design:type', core_2.DynamicFormControlModel)
	    ], DynamicFormBootstrapComponent.prototype, "model", void 0);
	    __decorate([
	        core_1.Input(), 
	        __metadata('design:type', Boolean)
	    ], DynamicFormBootstrapComponent.prototype, "hasSuccessStyles", void 0);
	    __decorate([
	        core_1.Input(), 
	        __metadata('design:type', Boolean)
	    ], DynamicFormBootstrapComponent.prototype, "hasErrorStyles", void 0);
	    __decorate([
	        core_1.ContentChild(core_1.TemplateRef), 
	        __metadata('design:type', Object)
	    ], DynamicFormBootstrapComponent.prototype, "customTemplate", void 0);
	    DynamicFormBootstrapComponent = __decorate([
	        core_1.Component({
	            selector: "dynamic-form-bootstrap-control",
	            template: "<div class=\"form-group\" [class.has-error]=\"hasErrorStyles && control.touched && !control.valid\" [class.has-success]=\"hasSuccessStyles && control.touched && control.valid\" [formGroup]=\"controlGroup\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\" [ngSwitch]=\"model.type\"><label *ngIf=\"!isCheckbox && model.label\" [attr.for]=\"model.id\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\">{{model.label}}</label><div *ngSwitchCase=\"'CHECKBOX'\" [ngClass]=\"model.cls.grid.control\"><div class=\"checkbox\" [class.disabled]=\"model.disabled\"><label [attr.for]=\"model.id\" [ngClass]=\"model.cls.element.label\"><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [value]=\"model.value\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\">{{model.label}}</label></div></div><div *ngIf=\"!isCheckbox\" [ngClass]=\"model.cls.grid.control\"><div *ngSwitchCase=\"'ARRAY'\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><fieldset *ngFor=\"let idx = index; let groupModel of model.groups\" [formGroupName]=\"idx\"><dynamic-form-bootstrap-control *ngFor=\"let controlModel of groupModel.group\" [controlGroup]=\"control.at(idx)\" [model]=\"controlModel\"></dynamic-form-bootstrap-control><template [ngTemplateOutlet]=\"customTemplate\" [ngOutletContext]=\"groupModel\"></template></fieldset></div><fieldset *ngSwitchCase=\"'GROUP'\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><dynamic-form-bootstrap-control *ngFor=\"let controlModel of model.group\" [controlGroup]=\"control\" [model]=\"controlModel\"></dynamic-form-bootstrap-control></fieldset><fieldset *ngSwitchCase=\"'CHECKBOX_GROUP'\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><div *ngFor=\"let item of model.group\" class=\"checkbox\" [class.disabled]=\"model.disabled\"><label [attr.for]=\"item.id\" [ngClass]=\"item.cls.element.label\"><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [formControlName]=\"item.id\" [name]=\"item.name\" [ngClass]=\"item.cls.element.control\" [required]=\"model.required\" [value]=\"item.value\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"item.value\">{{model.label}}</label></div></fieldset><div *ngSwitchCase=\"'INPUT'\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\">{{model.prefix}}</div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\">{{model.suffix}}</div><datalist *ngIf=\"model.list\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"'RADIO_GROUP'\" role=\"radiogroup\" [attr.tabindex]=\"model.tabIndex\" [name]=\"model.name\" (change)=\"onChange($event)\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><div *ngFor=\"let option of model.options\" class=\"radio\"><label><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [value]=\"option.value\" [(ngModel)]=\"model.value\">{{option.label}}</label></div></fieldset><select *ngSwitchCase=\"'SELECT'\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\"><option *ngFor=\"let option of model.options\" [attr.name]=\"model.name\" [ngValue]=\"option.value\">{{option.label}}</option></select><textarea *ngSwitchCase=\"'TEXTAREA'\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\"></textarea><span *ngIf=\"model.hint\" class=\"help-block\">{{model.hint}}</span></div><ng-content></ng-content></div>"
	        }), 
	        __metadata('design:paramtypes', [])
	    ], DynamicFormBootstrapComponent);
	    return DynamicFormBootstrapComponent;
	}(core_2.DynamicFormControlComponent));
	exports.DynamicFormBootstrapComponent = DynamicFormBootstrapComponent;

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var core_1 = __webpack_require__(16);
	var common_1 = __webpack_require__(17);
	var forms_1 = __webpack_require__(18);
	var core_2 = __webpack_require__(22);
	var dynamic_form_bootstrap_component_1 = __webpack_require__(24);
	var DynamicFormsBootstrapUIModule = (function () {
	    function DynamicFormsBootstrapUIModule() {
	    }
	    DynamicFormsBootstrapUIModule = __decorate([
	        core_1.NgModule({
	            imports: [
	                common_1.CommonModule,
	                forms_1.FormsModule,
	                forms_1.ReactiveFormsModule,
	                core_2.DynamicFormsCoreModule
	            ],
	            declarations: [
	                dynamic_form_bootstrap_component_1.DynamicFormBootstrapComponent
	            ],
	            exports: [
	                core_2.DynamicFormsCoreModule,
	                dynamic_form_bootstrap_component_1.DynamicFormBootstrapComponent
	            ]
	        }), 
	        __metadata('design:paramtypes', [])
	    ], DynamicFormsBootstrapUIModule);
	    return DynamicFormsBootstrapUIModule;
	}());
	exports.DynamicFormsBootstrapUIModule = DynamicFormsBootstrapUIModule;

/***/ }
/******/ ])
});
;